close all
clear all

scelta=menu('Selezionare immagine che si desidera elaborare: ','GATTI','ESCHER','MRI','MANO','LENA');
switch scelta
    case 1
    x_image = imread('gatti.jpg');
    case 2
    x_image = imread('fish.jpg');
    case 3
    x_image = imread('sagittal.jpg');
    case 4
    x_image = imread('mano.jpg');
    case 5
    x_image = imread('lena256.pgm');
    otherwise
    error('E''POSSIBILE INSERIRE SOLO NUMERI DA 1 A 5, PREGO RILANCIARE IL PROGRAMMA');
end
A_d=double(x_image);
siz = size(A_d);
if length(siz)>2
    im = A_d(:,:,1);
else
    im = A_d;
end

%Bordare l'immagine per BC Neumann
r = siz(1); c = siz(2);
A=zeros(r+2,c+2);
A(2:r+1,2:c+1)=im;
A(2:r+1,1)=A(2:r+1,2);
A(2:r+1,c+2)=A(2:r+1,c+1);
A(1,1:c+2)=A(2,1:c+2);
A(r+2,1:c+2)=A(r+1,1:c+2);

figure
imshow(uint8(A));

%Aggiunta Rumore all'immagine 
%rum=input('Selezionare intensit del rumore aggiunto: ');
rum=0.4
iter=input('Selezionare numero di iterazioni ');

%adds Gaussian white noise of mean M and variance V to the image I. 
A_rum = addnoise(A,rum); 
 
figure
subplot(2,3,1)
imshow(uint8(A));
title('Immagine originale'); 
subplot(2,3,2)
imshow(uint8(A_rum));
title('Aggiunta di rumore');

A_cal=calore(A_rum,iter);
subplot(2,3,4)
imshow(uint8(A_cal))
%imagesc(A_cal/max(max(A_cal)));
title('Equazione calore 2D');



% Calcolo errore 
erroreHeat = norm(A_cal - A,'fro') / norm(A,'fro')
